#ifndef EMSubataWrapper_WRAPPER_HEADER_H
#define EMSubataWrapper_WRAPPER_HEADER_H

#include "sub/SubDataWrapper.h"
#include "dpc_em/executable.h"

template <typename DataType>
class SLAM2EMposition_SubDataWrapper :  public SubDataWrapper<DataType>
{
private:
dpc::position* _data = nullptr;

public:

	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::position*)ptr->Get();
    }

	void GetData(dpc::position& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMattribute_SubDataWrapper :  public SubDataWrapper<DataType>
{
private:
dpc::attribute* _data = nullptr;

public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::attribute*)ptr->Get();
    }

	void GetData(dpc::attribute& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMline_point_SubDataWrapper :  public SubDataWrapper<DataType>
{
private:
dpc::line_point* _data = nullptr;

public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::line_point*)ptr->Get();
    }

	void GetData(dpc::line_point& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMline_SubDataWrapper : public SubDataWrapper<DataType>

{
	private:
	dpc::line* _data = nullptr;

	public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::line*)ptr->Get();
    }

	void GetData(dpc::line& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMspeed_limit_SubDataWrapper : public SubDataWrapper<DataType>

{
private:
dpc::speed_limit* _data = nullptr;

public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::speed_limit*)ptr->Get();
    }

	void GetData(dpc::speed_limit& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMtraffic_object_SubDataWrapper : public SubDataWrapper<DataType>

{
private:
dpc::traffic_object* _data = nullptr;
public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::traffic_object*)ptr->Get();
    }

	void GetData(dpc::traffic_object& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMlane_SubDataWrapper : public SubDataWrapper<DataType>

{
private:
dpc::Lane* _data = nullptr;

public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::Lane*)ptr->Get();
    }

	void GetData(dpc::Lane& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMroad_edge_SubDataWrapper : public SubDataWrapper<DataType>

{
private:
dpc::RoadEdge* _data = nullptr;

public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
		_data = (dpc::RoadEdge*)ptr->Get();
    }

	void GetData(dpc::RoadEdge& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class SLAM2EMslam_road_model_SubDataWrapper : public SubDataWrapper<DataType>

{
private:
dpc::slam_road_model* _data = nullptr;

public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
//        std::cout << "here is line: " << __LINE__ << std::endl;

		_data = (dpc::slam_road_model*)ptr->Get();
    }

	void GetData(dpc::slam_road_model& data)
	{
//		        std::cout << "here is line: " << __LINE__ << std::endl;
		        if(_data)
		        {
//        	        std::cout << "here is line: " << __LINE__ << std::endl;
        	        data = *_data;
//        	        std::cout<<   "cycle counter in get data is: "<<                                          data.cycle_counter << std::endl;
//        	                        std::cout << data.lanes[0].left_line_id << std::endl;
//        	                        std::cout << data.lanes[0].right_line_id << std::endl;


		        }
//    	        std::cout << "here is line: " << __LINE__ << std::endl;



	}

};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class Fusion2EMObjects_SubDataWrapper :  public SubDataWrapper<DataType>


{
private:
dpc::TrafficParticipantStruct* _data = nullptr;

public:
	void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        std::cout << "here is line: " << __LINE__ << std::endl;

		_data = (dpc::TrafficParticipantStruct*)ptr->Get();
    }

	void GetData(dpc::TrafficParticipantStruct& data)
	{
		if(_data)
			data = *_data;
	}
};

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class CAN2EM_SubDataWrapper : public SubDataWrapper<DataType>

{
	void Process(ara::com::SamplePtr<DataType const> *ptr) override
	{
		auto sample = ptr->Get();
		// std::cout<<"Received ses_en_sts data from CAN is: "<< sample->VCU_Info_1_Signals.ses_en_sts << std::endl;

	}
};


#endif
